#pragma once

#include "TrayIcon.h"

// #define ID_SHOW_CONFIG			111
// #define ID_QUIT_NTOOLSUPDATER	112
// #define ID_SHOW_NTOOLSUPDATER	113
// #define ID_HIDE_TRAYICON		114

const UINT WM_TRAY_NOTIFY					= WM_USER+123;
const UINT WM_NTOOLSUPDATER_UPDATE			= WM_USER+125;
const UINT WM_TRAY_SHOW						= WM_USER+126;
const UINT WM_TRAY_HIDE						= WM_USER+127;
const UINT WM_NTOOLSUPDATER_TRAYICON_STATUS	= WM_USER+128;

class CTrayWindow : public CWindowImpl<CTrayWindow>
{
public:
	//  Ŭ 
	DECLARE_WND_CLASS(_T("CTrayWindow"));

	CTrayWindow() : m_TrayIcon(NULL), m_bIsUpdate(FALSE), m_hMainHwnd(NULL), m_bTrayStatus(FALSE)
	{

	}

	~CTrayWindow()
	{
		::DestroyWindow(m_hWnd);
	}

private:
	// ޼ 
	BEGIN_MSG_MAP(CTrayWindow)
		MESSAGE_HANDLER(WM_CREATE, OnCreate)
		MESSAGE_HANDLER(WM_TASKBARCREATED, OnTaskbarCreated)
		MESSAGE_HANDLER(WM_DESTROY, OnDestroy)
		MESSAGE_HANDLER(WM_TRAY_NOTIFY, OnTrayIconCallback)
		MESSAGE_HANDLER(WM_TRAY_SHOW, OnShowFromNtoolsUpdater)
		MESSAGE_HANDLER(WM_TRAY_HIDE, OnHideFromNtoolsUpdater)
		MESSAGE_HANDLER(WM_TIMER, OnTimer)
		COMMAND_ID_HANDLER( ID_SHOW_CONFIG, OnShowConfig )
		COMMAND_ID_HANDLER( ID_QUIT_NTOOLSUPDATER, OnQuit )
		COMMAND_ID_HANDLER( ID_SHOW_NTOOLSUPDATER, OnViewOpen )
		COMMAND_ID_HANDLER( ID_HIDE_TRAYICON, OnTrayHide )
		MESSAGE_HANDLER(WM_NTOOLSUPDATER_UPDATE, OnUpdate)
		MESSAGE_HANDLER(WM_NTOOLSUPDATER_TRAYICON_STATUS, OnUpdaterTrayIconStatus)
	END_MSG_MAP()

	UINT SendMessageToNToolsUpdater( UINT msg );
	BOOL Show();
	void Hide();
	void Restart();
	BOOL IsUpdating();
	BOOL IsShow(){ return NULL != m_TrayIcon; }

	LRESULT OnUpdate(UINT msg, WPARAM wParam, LPARAM lParam, BOOL& bHandle);

	LRESULT OnTaskbarCreated(UINT msg, WPARAM wParam, LPARAM lParam, BOOL& bHandle){
		Restart();
		return 1;
	}

	LRESULT OnCreate(UINT msg, WPARAM wParam, LPARAM lParam, BOOL& bHandle);
	LRESULT OnDestroy(UINT, WPARAM, LPARAM, BOOL&){
		Hide();
		PostQuitMessage(0);
		return 0;
	}

	void ShowTooltip(const TCHAR *text);
	void SetUpdatingToolTip();
	void SetEmptyToolTip();

	LRESULT OnTrayIconCallback(UINT nMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	LRESULT OnShowFromNtoolsUpdater(UINT nMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	LRESULT OnHideFromNtoolsUpdater(UINT nMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);

	LRESULT OnUpdaterTrayIconStatus(UINT nMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	LRESULT OnShowConfig(WORD w1, WORD w2, HWND hWnd, BOOL& bHandled);
	LRESULT OnViewOpen(WORD w1, WORD w2, HWND hWnd, BOOL& bHandled);
	LRESULT OnQuit(WORD w1, WORD w2, HWND hWnd, BOOL& bHandled);
	LRESULT OnTrayHide(WORD w1, WORD w2, HWND hWnd, BOOL& bHandled);
	LRESULT OnTimer(UINT nMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
private:
	UINT WM_TASKBARCREATED;
	BOOL m_bIsUpdate;
	BOOL m_bTrayStatus;
	CTrayIcon *m_TrayIcon;
	HWND m_hMainHwnd;
};

